import java.util.*;

class GrapheAlgo
{
    private static void _parcours_profondeur(Graphe g, int s, 
					     boolean[] marque)
    {	
	for (int i = g.premier_successeur(s); 
	     i != -1; i = g.successeur_suivant(s,i))
	    {
		if (marque[i] == false)
		    {
			marque[i] = true;
			_parcours_profondeur(g,i,marque);
		    } 
		
	    } 
    }

    static void parcours_profondeur(Graphe g, int s)
    {
	boolean [] marque;

	marque = new boolean [g.getNbSommet()];
	
	for(int i = 0; i< g.getNbSommet(); i ++)
	    marque[i] = false;
	
	marque[s] = true;
	_parcours_profondeur(g, s, marque); 
    }    

    static void parcours_largeur(Graphe g, int s)
    {
	LinkedList file = new LinkedList();
	boolean [] marque = new boolean [g.getNbSommet()];

	for(int i = 0; i< g.getNbSommet(); i ++)
	    marque[i] = false;

	file.addFirst(new Integer(s));

	marque[s] = true;

	while(!(file.isEmpty()))
	    {
		s = ((Integer) file.removeLast()).intValue();
		for (int i = g.premier_successeur(s); 
		     i!= -1; 
		     i = g.successeur_suivant(s,i))
		    {
			if (marque[i] == false)
			    {
				marque[i] = true;
				file.addFirst(new Integer(i));
			    }  
		    }
	    }
    }

    static void recherche_plus_court_chemin(Graphe g, int s)
    {
	LinkedList file     = new LinkedList();
	boolean   [] marque = new boolean [g.getNbSommet()];
	int [] distances    = new int [g.getNbSommet()];
	int [] parents      = new int [g.getNbSommet()];
	
	for(int i = 0; i< g.getNbSommet(); i ++)
	    {
		marque[i]    = false;
		parents[i]   = -1;
		distances[i] = -1;
	    }

	file.addFirst(new Integer(s));

	marque[s]    = true;
	distances[s] = 0;
	parents[s]   = -1;

	while(!(file.isEmpty()))
	    {
		s = ((Integer) file.removeLast()).intValue();
		for (int i = g.premier_successeur(s); 
		     i!= -1; 
		     i = g.successeur_suivant(s,i))
		    {
			if (marque[i] == false)
			    {
				marque[i]    = true;
				distances[i] = distances[s] + 1;
				parents[i]   = s;
				file.addFirst(new Integer(i));
			    }  
		    }
	    }
    }


    private static int cfcDesc (Graphe g, int s, int nb_cfc, 
				int[] numero_cfc, int[] rangs, int[] theta, 
				int rang, LinkedList pile, int n,
				boolean[] visite, boolean[] empile)
    {
	pile.addFirst(new Integer(s));
	empile[s] = true;
	visite[s] = true;

	rang++;
	rangs[s] = rang;
	theta[s] = rang;
	
	for(int k = g.premier_successeur(s); k != -1; k = g.successeur_suivant(s,k))
	    {
		if(!visite[k])
		    {
			nb_cfc = cfcDesc(g,k,nb_cfc,numero_cfc,rangs,theta,rang,pile,n,visite,empile);
			theta[s] = (theta[s] < theta[k]) ? theta[s] : theta[k];
		    }
		else 
		    if (empile[k])
			theta[s] = (theta[s] < rangs[k]) ? theta[s] : rangs[k];
	    }
	if(theta[s] == rangs[s])
	    {
		int top;
		do
		    {
			top = ((Integer) pile.removeFirst()).intValue();
			empile[top] = false;
			numero_cfc[top] = nb_cfc;
		    }while (top != s);
		nb_cfc++; 
	    }
	return nb_cfc;
    }
    
    static int[] cfc (Graphe g)
    {
	int nb_cfc = 0;
	int[] numero_cfc;
	int[] rangs;
	int[] theta;	
	int i; 
	int rang = 0;
	LinkedList pile = new LinkedList();	
	int n; // nb de sommets
	n = g.getNbSommet();
	boolean[] visite;
	boolean[] empile;

	rangs = new int[n];
	theta = new int [n];
	numero_cfc = new int [n];
	visite = new boolean[n];
	empile = new boolean[n];

	for(i = 0; i < n; i++)
	    {
		rangs[i]      = -1;
		theta[i]      = -1;
		numero_cfc[i] = -1;
		visite[i]     = false;
		empile[i]     = false;
	    }

	for(i = 0; i < n; i++)
	    if (!visite[i])
		nb_cfc = cfcDesc(g,i,nb_cfc,numero_cfc,rangs,theta,rang,pile,n,visite,empile);
	return numero_cfc;
    }
}











