import java.util.*;

public class GrapheListeChainee implements Graphe
{
    LinkedList [] l;
    private int nbsommets;
 
    public GrapheListeChainee(int sommets)
    {
	l = new LinkedList[sommets];

	for (int i = 0; i < sommets; i++)
	    l[i] = new LinkedList();

	nbsommets = sommets;
    }


    public boolean est_vide()
    {
	return (nbsommets == 0);
    }

    public boolean est_arc(int s1, int s2)
    {
	if(s1 < 0 || s2 < 0 || s1 > nbsommets || s2 > nbsommets)
	    return false;

	for (int j = 0; j < l[s1].size(); j++)
	    {
		if( ((Integer) l[s1].get(j)).intValue() == s2)
		    return true;
	    }

	return false;
    }

    public int degre_plus(int s)
    {
	int i;

	for (i = 0; ieme_successeur(s, i) != -1; i++)
	    ;

	return i;
    }

    public int degre_moins(int s)
    {
	int i;
	
	for (i = 0; ieme_predecesseur(s, i) != -1; i++)
	    ;
	
	return i;
    }
    
    /**
       Ajoute l'arc de valuation <i>val</i> reliant <i>s1</i>  <i>s2</i>
    */
    public void ajouter_arc(int s1,  int s2)
    {
	if(s1 < 0 || s1 > nbsommets || s2 < 0 || s2 > nbsommets)
	    return;

	if(est_arc(s1, s2))
	    return;

	l[s1].addFirst(new Integer(s2));
    }

    public void    supprimer_arc(int s1, int s2)
    {
	if(s1 < 0 || s1 > nbsommets || s2 < 0 || s2 > nbsommets)
	    return;

	for (int i = 0; i < l[s1].size(); i++)
	    {
		if(((Integer) l[s1].get(i)).intValue() == s2)
		    {
			l[s1].remove(i);
			break;
		    }
	    }
    }

    public int  ieme_successeur(int s, int cpt)
    {
	if(s < 0 || s > nbsommets)
	    return -1;

	for (int i = 0; i < l[s].size(); i++)
	    {
		if(cpt == i)
		    return ((Integer) l[s].get(i)).intValue();
		cpt++;
	    }
	
	return -1;
    }

    public int  ieme_predecesseur(int s, int ieme)
    {
	int cpt = 0;
	
	for (int i = 0; i < nbsommets; i++)
	    {
		for (int j = 0; j < l[i].size(); j++)
		    {
			if( ((Integer) l[i].get(j)).intValue() == s)
			    {
				if(cpt == ieme)
				    return i;
				else
				    cpt++;
			    }
		    }
	    }

	return -1;
    }
    
    public int  premier_successeur(int s)
    {
	if(s < 0 || s > nbsommets)
	    return -1;

	if(l[s].size() > 0)
	    return ((Integer) l[s].get(0)).intValue();
	else 
	    return -1;
    }

    public int   successeur_suivant(int s1, int s2)
    {
	if(s1 < 0 || s2 < 0 || s1 > nbsommets || s2 > nbsommets)
	    return -1;
	
	for (int i = 0; i < nbsommets; i++)
	    {
		for (int j = 0; j < l[s1].size(); j++)
		    {
			if( ((Integer) l[s1].get(j)).intValue() == s2)
			    {
				if(j+1 == l[s1].size())
				    return -1;
				else
				    return ((Integer) l[s1].get(j+1)).intValue();
			    }
		    }
	    }

	return -1;
    }

    public int getNbSommet()
    {
	return nbsommets;
    }
}
