public class GrapheMatrix implements Graphe
{
    private int nb_sommet;
    private int ident;

    private int[][] matrix;
    
    public GrapheMatrix(int sommets)
    {
	nb_sommet = sommets;
	ident = 0;
	matrix  = new int[sommets][sommets];
    }

    public int getNbSommet()
    {
	return nb_sommet;
    }
   
    public void ajouter_arc(int s1, int s2)
    {
	if(s1 < 0 || s2 < 0)
	    {
		System.out.println("Ces sommets n'appartiennent pas au graphe");
		return;
	    }

	if (est_arc(s1, s2) == true)
	    {
		System.out.println("Cet arc existe dj");
		return;
	    }

	matrix[s1][s2] = 1;
    }

    public void supprimer_arc(int s1,  int s2)
    {
	if(s1 < 0 || s2 < 0)
	    {
		System.out.println("Ces sommets n'appartiennent pas au graphe");
		return;
	    }

	if(est_arc(s1, s2) == false)
	    {
		System.out.println("L'arc n'appartient pas au graphe");
		return;
	    }

	matrix[s1][s2] = 0;
    }

    public boolean est_vide()
    {
	return (nb_sommet == 0);
    }

    public boolean est_sommet(int s)
    {
	if(s > 0 && s < nb_sommet)
	    return true;
	else
	    return false;
    }

    public boolean est_arc(int s1, int s2)
    {
	int i;

	if(s1 < 0 || s1 > nb_sommet || s2 < 0 || s2 > nb_sommet)
	    {
		System.out.println("Ces sommets n'appartiennent pas au graphe");
		return false;
	    } 

	return (matrix[s1][s2] != 0);
    }

    public int degre_plus(int s)
    {
	int cpt = 0;

	if(s < 0 || s > nb_sommet)
	    {
		System.out.println("Ces sommets n'appartiennent pas au graphe");
		return -1;
	    } 

	for(int i = 0; i < nb_sommet; i = i + 1)
	    {
		if (matrix[s][i] != 0)
		    cpt = cpt + 1;
	    }
	return cpt;
    }

    public int degre_moins(int s)
    {
	int cpt = 0;

	if(s < 0 || s > nb_sommet)
	    {
		System.out.println("Ces sommets n'appartiennent pas au graphe");
		return -1;
	    } 

	for(int i = 0; i < nb_sommet; i = i + 1)
	    {
		if (matrix[i][s] != 0)
		    cpt = cpt + 1;
	    }
	return cpt;
    }

    public int ieme_successeur(int s, int num)
    {
	int i, cpt = 0;

	if(s < 0 || s > nb_sommet)
	    {
		System.out.println("Ces sommets n'appartiennent pas au graphe");
		return -1;
	    } 
	 
	for(i = 0; i < nb_sommet; i ++)
	    {
		if (matrix[s][i] != 0 && cpt == num)
		    return i;
		if (matrix[s][i] != 0)
		    cpt ++;
	    }

	return -1;
    }

    public int ieme_predecesseur(int s,int num)
    {
	int i, cpt = 0;

	if(s < 0 || s > nb_sommet)
	    {
		System.out.println("Ces sommets n'appartiennent pas au graphe");
		return -1;
	    } 
	 
	for(i = 0; i < nb_sommet; i ++)
	    {
		if (matrix[i][s] != 0 && cpt == num)
		    return i;
		if(matrix[i][s] != 0)
		    cpt++;
	    }

	return -1;
    }

    public int  premier_successeur(int s)
    {
	return ieme_successeur(s,0);
    }

    public int  successeur_suivant(int s1, int s2)
    {
	int i;

	if(s1 < 0 || s1 > nb_sommet || s2 < 0 || s2 > nb_sommet)
	    {
		System.out.println("Ces sommets n'appartiennent pas au graphe");
		return -1;
	    } 

	for (i = s2 + 1; i < nb_sommet; i++)
	    {
		if (matrix[s1][i] != 0)
		    return i;  
	    }

	return -1;
    }    
}
